# -*- coding: utf-8 -*-
"""
Created on Fri Nov 24 18:49:08 2016

@author: orycho
"""
###################################
import numpy as np
from matplotlib.lines import Line2D
import matplotlib.pyplot as plt
import matplotlib.animation as animation
import matplotlib
import threading
import socket
import subprocess
import time
import sys
from struct import Struct
matplotlib.style.use('ggplot')
###################################
HOST = '127.0.0.1'
PORT = 8099
FILENAME = 'main.tcl'
###################################
TotalData = []
Data=[]
###################################
def OTCP():
    global Data,TotalData,HOST,PORT
    
    tcpSerSock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    tcpSerSock.bind((HOST, PORT))
    
    tcpSerSock.listen(5)
    unpacker = Struct('d')
    while True:
        print('waiting for connection...')
        (tcpCliSock, address) = tcpSerSock.accept()
        print('Connected from:',address)
        
    
        datarecv = tcpCliSock.recv(unpacker.size)
        DataSize = unpacker.unpack(datarecv)[0]
        
        print('Data Size == {0}'.format(DataSize))
        
        SizeReceived = 0
        while True:
            try:
                datarecv = tcpCliSock.recv(unpacker.size)
            
                if SizeReceived > 0:	
                    Data.append(unpacker.unpack(datarecv)[0])
            
    
                if SizeReceived == DataSize:
                    SizeReceived = 0
                    TotalData=Data
#                    print(TotalData)
#                    print(Data)
                    Data = []
                else:
                    SizeReceived += 1
            except:
                print('disconnect from:', address)
                tcpCliSock.close()  # 退出
                break
        
    tcpSerSock.close()
###################################

###################################
def COPS():
    try:
        outPuts = subprocess.check_output(['opensees',FILENAME])
    except subprocess.CalledProcessError as e:
        outPuts = e.output
        code = e.returncode
        print(outPuts)
        print(code)
        
###################################

# Axis setting
xRange = 1
ymin = -1
ymax = 1

class Scope(object):
    def __init__(self, ax, maxt=xRange):
        self.ax = ax
        self.maxt = maxt
        self.xdata = [0]
        self.ydata = [0]
        self.line = Line2D(self.xdata, self.ydata, ls='-',lw = 2, 
                           alpha=0.8, color='gray')
        self.ax.add_line(self.line)
        self.ax.set_ylim(ymin, ymax)
        self.ax.set_xlim(0, self.maxt)

    def update(self, y):
        lastx = self.xdata[0] + y[0]
        if lastx > self.xdata[0] + 3/4*self.maxt:
#            self.xdata = [self.xdata[-1]]
#            self.ydata = [self.ydata[-1]]
            self.ax.set_xlim(self.xdata[0], max(self.maxt,5/4*lastx))
            self.ax.figure.canvas.draw()
        lasty = y[1]
        if lasty > max(self.ydata):
            temp = self.ax.get_ylim()[0]
            self.ax.set_ylim(temp, max(ymax,5/4*y[1]))
            self.ax.figure.canvas.draw()
        elif lasty < min(self.ydata):
            temp = self.ax.get_ylim()[1]
            self.ax.set_ylim(min(ymin,5/4*y[1]), temp)
            self.ax.figure.canvas.draw()

        x = self.xdata[0] + y[0]
        self.xdata.append(x)
        self.ydata.append(y[1])
        self.line.set_data(self.xdata, self.ydata)
        return self.line


def emitter():
    while True:
        yield (TotalData[0],TotalData[1])

        

OTread = threading.Thread(target=OTCP, name='OTCP')
OTread.start()
OCOPS = threading.Thread(target=COPS, name='COPS')
OCOPS.start()
time.sleep(3)
fig, ax = plt.subplots(figsize=(10, 8), dpi=80, facecolor='w', edgecolor='k')
plt.xlabel('Time',fontname="Times New Roman",fontsize = 15)
plt.ylabel('Disp',fontname="Times New Roman",fontsize = 15)
for tick in ax.get_xticklabels():       # 设置标签字体
    tick.set_fontname("Times New Roman")
    tick.set_fontsize(15)
for tick in ax.get_yticklabels():
    tick.set_fontname("Times New Roman")
    tick.set_fontsize(15)
scope = Scope(ax)

# pass a generator in "emitter" to produce data for the update func
ani = animation.FuncAnimation(fig, scope.update, frames = emitter, interval=100,
                              blit=False)

plt.show()
sys.exit()